//---------------------------------------------------------------------------
#ifndef ADAMEmMamMainH
#define ADAMEmMamMainH
//---------------------------------------------------------------------------
#include <vcl\Classes.hpp>
#include <vcl\Controls.hpp>
#include <vcl\StdCtrls.hpp>
#include <vcl\Forms.hpp>
#include <vcl\ComCtrls.hpp>
#include <vcl\ExtCtrls.hpp>
#include <vcl\Buttons.hpp>
#include <vcl\Dialogs.hpp>
//---------------------------------------------------------------------------
class TADAMEmMamMainForm : public TForm
{
__published:	// IDE-managed Components
	TTabSheet *PathsSheet;
	TPanel *ADAMEmPathPanel;
	TPanel *EOSPanel;
	TTabSheet *ImagesSheet;
	TTabSheet *MiscSheet;
	TLabel *Label1;
	TLabel *Label2;
	TPanel *WPPanel;
	TLabel *Label3;
	TPanel *OS7Panel;
	TLabel *Label4;
	TEdit *ADAMEmPathEdit;
	TBitBtn *ADAMEmPathButton;
	TBitBtn *EOSButton;
	TBitBtn *WPButton;
	TBitBtn *OS7Button;
	TEdit *OS7Edit;
	TEdit *WPEdit;
	TPanel *CassetteAPanel;
	TLabel *Label6;
	TEdit *CassetteAEdit;
	TBitBtn *CassetteAButton;
	TPanel *DiskAPanel;
	TLabel *Label7;
	TEdit *DiskAEdit;
	TBitBtn *DiskAButton;
	TPanel *DiskBPanel;
	TLabel *Label8;
	TEdit *DiskBEdit;
	TBitBtn *DiskBButton;
	TPanel *DiskCPanel;
	TLabel *Label9;
	TEdit *DiskCEdit;
	TBitBtn *DiskCButton;
	TPanel *DiskDPanel;
	TLabel *Label10;
	TEdit *DiskDEdit;
	TBitBtn *DiskDButton;
	TPanel *CassetteBPanel;
	TLabel *Label5;
	TEdit *CassetteBEdit;
	TBitBtn *CassetteBButton;
	TPanel *StartupDirPanel;
	TLabel *Label11;
	TEdit *StartupDirectoryEdit;
	TBitBtn *StartupDirectoryButton;
	TRadioGroup *EmulationModeRadioGroup;
	TPanel *IFreqPanel;
	TLabel *Label15;
	TUpDown *IFreqUpDown;
	TEdit *IFreqEdit;
	TPanel *CPUSpeedPanel;
	TLabel *Label16;
	TUpDown *CPUSPeedUpDown;
	TEdit *CPUSpeedEdit;
	TTabSheet *UserSheet;
	TLabel *Label19;
	TMemo *UserOptionsMemo;
	TMemo *Memo2;
	TTabSheet *OptionsSheet;
	TLabel *Label18;
	TMemo *OptionsMemo;
	TTabSheet *ReadMeSheet;
	TLabel *Label20;
	TBitBtn *ADAMEmMamReadMeButton;
	TMemo *ADAMEmMamReadMeMemo;
	TBitBtn *ADAMEmReadMeButton;
	TLabel *Label21;
	TMemo *ADAMEmReadMeMemo;
	TGroupBox *ExpansionGroupBox;
	TComboBox *ExpansionModuleComboBox;
	TLabel *Label22;
	TRadioButton *ExpansionMouseRadioButton;
	TRadioButton *ExpansionJoystickRadioButton;
	TRadioGroup *JoystickRadioGroup;
	TLabel *Label24;
	TEdit *SensitivityEdit;
	TUpDown *SensitivityUpDown;
	TCheckBox *CalibrateCheckBox;
	TPageControl *MainPageControl;
	TPanel *CartridgePanel;
	TLabel *Label29;
	TBitBtn *CartridgeButton;
	TEdit *CartridgeEdit;
	TTabSheet *VideoSoundSheet;
	TGroupBox *SoundGroupBox;
	TPanel *SoundDevicePanel;
	TLabel *Label12;
	TComboBox *SoundComboBox;
	TPanel *ReverbPanel;
	TLabel *Label26;
	TEdit *ReverbLevelEdit;
	TUpDown *ReverbLevelUpDown;
	TGroupBox *SpeakerChannelsGroupBox;
	TLabel *Label30;
	TLabel *Label31;
	TLabel *Label32;
	TLabel *Label33;
	TEdit *SpeakerChannelAEdit;
	TEdit *SpeakerChannelBEdit;
	TEdit *SpeakerChannelCEdit;
	TEdit *SpeakerChannelDEdit;
	TUpDown *SpeakerChannelAUpDown;
	TUpDown *SpeakerChannelBUpDown;
	TUpDown *SpeakerChannelCUpDown;
	TUpDown *SpeakerChannelDUpDown;
	TPanel *VolumePanel;
	TLabel *Label17;
	TEdit *VolumeEdit;
	TUpDown *VolumeUpDown;
	TPanel *ChorusPanel;
	TLabel *Label27;
	TEdit *ChorusLevelEdit;
	TUpDown *ChorusLevelUpDown;
	TPanel *SoundQualityPanel;
	TLabel *Label23;
	TEdit *SoundQualityEdit;
	TUpDown *SoundQualityUpDown;
	TPanel *PanningPanel;
	TLabel *Label28;
	TEdit *PanningLevelEdit;
	TUpDown *PanningLevelUpDown;
	TPanel *SoundLogPanel;
	TLabel *Label25;
	TBitBtn *SoundLogButton;
	TEdit *SoundLogEdit;
	TGroupBox *VideoGroupBox;
	TRadioGroup *VideoModeRadioGroup;
	TPanel *UPeriodPanel;
	TLabel *Label13;
	TUpDown *UPeriodUpDown;
	TEdit *UPeriodEdit;
	TCheckBox *OverscanCheckBox;
	TCheckBox *ShowAllSpritesCheckBox;
	TGroupBox *ButtonsGroupBox;
	TCheckBox *SwapJoystickButtonsCheckBox;
	TCheckBox *SwapKeyboardButtonsCheckBox;
	TCheckBox *SwapMouseButtonsCheckBox;
	TRadioGroup *PrinterTypeRadioGroup;
	TPanel *PrinterLogPanel;
	TLabel *Label14;
	TBitBtn *PrinterLogButton;
	TEdit *PrinterLogEdit;
	
	TCheckBox *ReverseKeypadCheckBox;
	TGroupBox *MiscGroupBox;
	TCheckBox *VerboseCheckBox;
	TCheckBox *SyncCheckBox;
	TEdit *EOSEdit;
	TOpenDialog *OpenDialogue;
	TPanel *ButtonPanel;
	TBitBtn *LaunchButton;
	TBitBtn *CloseButton;
	TBitBtn *DefaultButton;
	TBitBtn *AboutButton;
	TRadioGroup *PaletteRadioGroup;
	TRadioGroup *TDOSRadioGroup;
	TPanel *ParallelLogPanel;
	TLabel *Label34;
	TBitBtn *ParallelLogButton;
	TEdit *ParallelLogEdit;
	TPanel *ExpansionRAMPanel;
	TLabel *Label35;
	TEdit *ExpansionRAMEdit;
	TUpDown *ExpansionRAMUpDown;
	TPanel *SnapPanel;
	TLabel *Label36;
	TBitBtn *SnapButton;
	TEdit *SnapEdit;
	TCheckBox *AutoSnapCheckBox;
	void __fastcall AboutButtonClick(TObject *Sender);
	void __fastcall OpenButtonClick(TObject *Sender);
	void __fastcall StringEditExit(TObject *Sender);
	void __fastcall RadioGroupClick(TObject *Sender);
	void __fastcall RadioButtonClick(TObject *Sender);
	void __fastcall CheckBoxClick(TObject *Sender);
	void __fastcall EditExit(TObject *Sender);
	void __fastcall ComboBoxChange(TObject *Sender);
	void __fastcall MainPageControlChange(TObject *Sender);
	void __fastcall FormCreate(TObject *Sender);
	void __fastcall FormDestroy(TObject *Sender);
	void __fastcall ReadMeButtonClick(TObject *Sender);
	void __fastcall MemoExit(TObject *Sender);
	void __fastcall DefaultButtonClick(TObject *Sender);
	void __fastcall LaunchButtonClick(TObject *Sender);
	
private:	// User declarations
	TADAMEm *ADAMEm;
    void SetAllOptions (void);			// initialise all checkboxes, etc.
    void SetEmulatorOptions (void);		// initialise OptionsMemo
    void UpdateAllOptions (void);		// parse newly entered values
	AnsiString ReadMeFile;				// ADAMEmMam.txt path
    AnsiString IniFile;					// ADAMEmMam.ini path
    void UpdateTabSheet(TTabSheet*);	// Update all checkboxes, etc. on a particular sheet
public:		// User declarations
	__fastcall TADAMEmMamMainForm(TComponent* Owner);
};
//---------------------------------------------------------------------------
extern TADAMEmMamMainForm *ADAMEmMamMainForm;
//---------------------------------------------------------------------------
#endif
